clear all
close all
warning off
Ntr=200;%training set size: 200 o 1100
p=20;%estimate length: 50 o 110
pole=0.8;
q=1;%CI 95%
m=20;%the number of signed
ki=chi2inv(1-q/m,p);%for chi-squared CI
Runs=2000;%only for Gauss-Tsel2
%o2y=4^2;
%u=randn(1,Ntr);%*(sqrt(o2y)/p);%output variance is o2y
G=randn(Ntr,p);%toeplitz(u,zeros(1,p));%regression matrix
o2=1;%variance of Gaussian noise
%o2L=1;%Laplace prior variance
K=eye(p);%o2L*
%mu=0;%mean of Laplacian


MC=1;%Monte Carlo runs
for gg=1:MC;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%% DATA GENERATION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    f=randn(p,1);
    z=G*f;%noiseless output
    y=z+sqrt(o2).*sign(randn(Ntr,1)).*exprnd(1,1,Ntr)'/sqrt(2);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LS and ReLS%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    LS=inv(G'*G)*G'*y;%LS
    %o2LS=o2*(KnownVar==1)+(norm(y-G*LS)^2/(Ntr-p))*(KnownVar==0);%o2 used by LS
    E{1}=o2*inv(G'*G);
    C=inv(K);
    H=o2*C;%all the measurements y2 are affected by noise of variance o2 !
    G2=real([G;-H^0.5]);%chol(H)' could be H^0.5
    y2=[y;-(H^0.5)*0*ones(p,1)];%mean of Laplacian is zero
    ReLS=inv(G2'*G2)*G2'*y2;%ReLS
    E{2}=o2*inv(G2'*G2);%posterior from ReLS
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%% REGULARIZED LEAST SQUARES ReLS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %[Tsel1,Close1,Fit1,Close1Fast,V1,flag1,up1,down1] = SPSindsamp(G,y,LS,q,m,f,'LS+SPS',o2);%LS+SPS
    %[Tsel3,Close3,Fit3,flag3] = Gaussgibbs(E{2},ki,f,ReLS,Runs);%ReLS+Gauss
    [Tsel11,Close11,Fit11,Close11Fast,V11,flag11,~,up11,down11] = SPSindsampBayesLaplace(G2,y2,ReLS,q,m,f,'BayesLaplace',o2);%Gaussian meas, Laplacian f
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    clc
    %disp('LS+SPS LS+Gauss ReLS+Gauss ReLS+SPS1 ReLS+SPS2 ReLS+SPS1g ReLS+SPS2g ReLS+SPS3 ReLS+SPS4')
    %Flag(gian,:)=[flag1 flag3(1) flag11];clc;sum(Flag)/gian
    %Close(gian,:)=[Close1 Close3  Close11];
    %Fit(gian,:)=[Fit1 Fit3   Fit11];
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
end

AxFont=24;
xlabFont=28;
xlabFont2=28;%for final MSE plot
InLabFont=24;

fig=figure;
plot([1:Ntr],z,'k','LineWidth',1);hold on;grid on
plot([1:Ntr],y,'ko','LineWidth',1);
h=get(fig,'Children');set(h,'Fontsize',AxFont);
title('Output data','FontSize',xlabFont);
legend('Noiseless','Noisy data y','Location','northeast' )
%axis([0 200 -15 18])


fig=figure;
%for i=10:10:size(Tsel11,1);Q(i/10,:)=Tsel11(i,:)';end;
%plot(Q');hold on;
plot([1:p],f,'r','LineWidth',3);hold on;grid on
plot([1:p],max(Tsel11),'k--','LineWidth',2);
plot([1:p],min(Tsel11),'k--','LineWidth',2);
h=get(fig,'Children');set(h,'Fontsize',AxFont);
title('BFB','FontSize',xlabFont);a=axis;a(1)=0.8;a(2)=p+0.2;a(4)=3.3;a(3)=-2.2;axis(a)
%plot(up11);plot(down11)
legend('True','95% bounds','Location','northwest' )




% function [f,K]=Genf(lab,Randf,p);
% 
% if lab=='CS'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=(i*j*min(i,j)/2-(min(i,j)^3)/6);%Cubic spline
%         end;
%     end
%     f=mvnrnd(zeros(p,1),K,1)';
% elseif lab=='RW'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=min(i,j);%Random walk
%         end;
%     end
%     f=mvnrnd(zeros(p,1),K,1)';
% elseif lab=='LP'
%     K=eye(p);
%     f=sign(randn(p,1)).*exprnd(1,p,1)/sqrt(2);%Laplace of unit variance
% elseif lab=='TC'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=0.8^max(i,j);%Stable spline
%         end;
%     end
%     if Randf==1
%         f=mvnrnd(zeros(p,1),K,1)';
%     else
%         load IR%impulse response f
%         if length(f)<p
%             f(length(f)+1:p)=0;
%         elseif length(f)>p
%             f=f(1:p);
%         end
%     end
% end
% 
% end
