clear all
close all
warning off
Ntr=100;%training set size: 200 o 1000
p=100;%estimate length: 50 o 100
for i=1:p
    for j=1:p
        K(i,j)=10+min(i,j);
        K(i,j)=0*1000+(i*j*min(i,j)/2-(min(i,j)^3)/6);%0*1000 o 1000*
        %K(i,j)=exp(-inv(1000)*abs(i-j));
        %K(i,j)=exp(-inv(500)*((i-j)^2));
    end
end
K=1000*K/max(max(K));%maximum f variance is normalized
q=1;%CI 95%
m=20;%the number of signed
ki=chi2inv(1-q/m,p);%for chi-squared CI
Runs=2000;%only for Gauss-Tsel2
sel=[1:20 41:Ntr];%where data are available
Case=2;%2 - two variances on Sel
o2=mean(diag(K))/100;%0.2^2;%var(G*f)/10;
selVar=[1:40];%where variance is large
O2=50*o2;%the large variance

MC=1;%Monte Carlo runs
for gg=1:MC;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%% DATA GENERATION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    f=mvnrnd(zeros(1,p),K,1)';%chol(C)'*randn(p,1);
    close all;figure;plot(f);pause(1);
    G=eye(p);
    z=G*f;%noiseless output
    e=randn(Ntr,1);
    y=z+sqrt(o2)*e;
    if Case==2%use of selVar
        y(selVar)=z(selVar)+sqrt(O2)*e(selVar);  
    end
    G=G(sel,:);%use of sel
    y=y(sel);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LS and ReLS%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    LS=inv(G'*G)*G'*y;%LS
    %o2LS=o2*(KnownVar==1)+(norm(y-G*LS)^2/(Ntr-p))*(KnownVar==0);%o2 used by LS
    E{1}=o2*inv(G'*G);
    C=inv(K);
    H=o2*C;%all the measurements y2 are affected by noise of variance o2 !
    G2=real([G;-H^0.5]);%chol(H)' could be H^0.5
    y2=[y;zeros(p,1)];
    ReLS=inv(G2'*G2)*G2'*y2;%ReLS
    E{2}=o2*inv(G2'*G2);%posterior from ReLS
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%% REGULARIZED LEAST SQUARES ReLS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %               1          2           3            4            5           6          7           8                       
    %Cases=char({'LS+SPS','ReLS+SPS1','ReLS+SPS2','ReLS+SPS1g','ReLS+SPS2g','ReLS+SPS3','ReLS+SPS4','LASSO'});
    %[Tsel1,Close1,Fit1,Close1Fast,V1,flag1] = SPSindsamp(G,y,LS,q,m,f,'LS+SPS',o2);%LS+SPS
    %[Tsel2,Close2,Fit2,flag2] = Gaussgibbs(E{1},ki,f,LS,Runs);%LS+Gauss
    [Tsel3,Close3,Fit3,flag3] = Gaussgibbs(E{2},ki,f,ReLS,Runs);%ReLS+Gauss
    %[Tsel4,Close4,Fit4,Close4Fast,V4,flag4] = SPSindsamp(G2,y2,ReLS,q,m,f,'ReLS+SPS1',o2);%Signs on all
    %[Tsel5,Close5,Fit5,Close5Fast,V5,flag5] = SPSindsamp(G2,y2,ReLS,q,m,f,'ReLS+SPS2',o2);%Signs on meas, fixed reg
    %[Tsel6,Close6,Fit6,Close6Fast,V6,flag6] = SPSindsamp(G2,y2,ReLS,q,m,f,'ReLS+SPS1g',o2);%Gaussian meas, signs reg
    %[Tsel7,Close7,Fit7,Close7Fast,V7,flag7] = SPSindsamp(G2,y2,ReLS,q,m,f,'ReLS+SPS2g',o2);%Gaussian meas, fixed reg
    [Tsel8,Close8,Fit8,Close8Fast,V8,flag8,~,up8,down8] = SPSindsamp(G2,y2,ReLS,q,m,f,6,o2);%'ReLS+SPS3',o2);%Signs meas, Gaussian f
    [Tsel9,Close9,Fit9,Close9Fast,V9,flag9,~,up9,down9] = SPSindsamp(G2,y2,ReLS,q,m,f,7,o2);%'ReLS+SPS4',o2);%Gaussian meas, Gaussian f
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %clc
    %disp('LS+SPS LS+Gauss ReLS+Gauss ReLS+SPS1 ReLS+SPS2 ReLS+SPS1g ReLS+SPS2g ReLS+SPS3 ReLS+SPS4')
    %Flag(gian,:)=[flag1 flag2 flag3(1) flag4(1) flag5 flag6 flag7 flag8 flag9]
    %Close(gian,:)=[Close1 Close2  Close3  Close4  Close5 Close6 Close7 Close8 Close9]
    %Fit(gian,:)=[Fit1   Fit2   Fit3  Fit4   Fit5 Fit6 Fit7 Fit8 Fit9]
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
end

%%%%%%%%%%
AxFont=24;
xlabFont=28;
xlabFont2=28;%for final MSE plot
InLabFont=24;

fig=figure;
for i=20:20:size(Tsel9,1);Q(i/20,:)=Tsel9(i,:)';end;
plot(f,'r','LineWidth',3);hold on
plot([1:p],ReLS,'k','LineWidth',3);a=axis;
legend('True','Estimate','Location','northeast')
plot(Q');hold on;plot(sel,y,'ko');clear Q;
plot(f,'r','LineWidth',3);hold on
plot([1:p],ReLS,'k','LineWidth',3);
h=get(fig,'Children');set(h,'Fontsize',AxFont);grid on
legend('True','Estimate','Location','northeast')
title('Gaussian bounds','FontSize',xlabFont);a=axis;%a(1)=0.8;a(2)=p+0.2;a(4)=2.2;a(3)=-1.8;axis(a)
%plot(up11);plot(down11)
%legend('True','95% bounds','Location','northwest' )


fig=figure;
for i=20:20:size(Tsel8,1);Q(i/20,:)=Tsel8(i,:)';end;
plot(f,'r','LineWidth',3);hold on
plot([1:p],ReLS,'k','LineWidth',3);
legend('True','Estimate','Location','northeast')
plot(Q');hold on;plot(sel,y,'ko');clear Q;
plot(f,'r','LineWidth',3);hold on
plot([1:p],ReLS,'k','LineWidth',3);
h=get(fig,'Children');set(h,'Fontsize',AxFont);grid on
legend('True','Estimate','Location','northeast')
title('BFB','FontSize',xlabFont);axis(a);%a=axis;a(1)=0.8;a(2)=p+0.2;a(4)=2.2;a(3)=-1.8;
%plot(up11);plot(down11)
%legend('True','95% bounds','Location','northwest' )




% for i=10:10:size(Tsel3,1);Q(i/10,:)=Tsel3(i,:)';end
% plot(Q');hold on;plot(sel,y,'ko');hold on;plot(f,'r','LineWidth',2);clear Q;figure
% for i=20:20:size(Tsel8,1);Q(i/20,:)=Tsel8(i,:)';end;
% plot(Q');hold on;plot(sel,y,'ko');hold on;plot(f,'r','LineWidth',2);a=axis;clear Q;figure;
% for i=20:20:size(Tsel9,1);Q(i/20,:)=Tsel9(i,:)';end;
% plot(Q');hold on;plot(sel,y,'ko');axis(a);hold on;plot(f,'r','LineWidth',2);
%close all
%figure
%plot(Tsel1');hold on;plot(f,'LineWidth',2)
%figure
%plot(Tsel2');hold on;plot(f,'LineWidth',2)
%figure
%plot(Tsel3(10:10:end,:)');hold on;plot(f,'LineWidth',2);%a=axis;figure(1);axis(a)
%figure
%plot(Tsel4');hold on;plot(f,'LineWidth',2)


% function [f,K]=Genf(lab,Randf,p);
% 
% if lab=='CS'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=(i*j*min(i,j)/2-(min(i,j)^3)/6);%Cubic spline
%         end;
%     end
%     f=mvnrnd(zeros(p,1),K,1)';
% elseif lab=='RW'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=min(i,j);%Random walk
%         end;
%     end
%     f=mvnrnd(zeros(p,1),K,1)';
% elseif lab=='LP'
%     K=eye(p);
%     f=sign(randn(p,1)).*exprnd(1,p,1)/sqrt(2);%Laplace of unit variance
% elseif lab=='TC'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=0.8^max(i,j);%Stable spline
%         end;
%     end
%     if Randf==1
%         f=mvnrnd(zeros(p,1),K,1)';
%     else
%         load IR%impulse response f
%         if length(f)<p
%             f(length(f)+1:p)=0;
%         elseif length(f)>p
%             f=f(1:p);
%         end
%     end
% end

%end
