clear all
close all
warning off
q=1;%CI 95%
m=20;%the number of signed
Runs=2000;%only for Gauss-Tsel2
p=100;
Ntr=p;
t=[1:p];


MC=1;%Monte Carlo runs
for gg=1:MC;gg
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%% DATA GENERATION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Noise variances generation
    a=0.15;b=0.5;c=0.5;
    for i=1:p
        for j=1:p
            N(i,j)=5*((a^2)/(1-c^2))*a^(abs(t(i)-t(j)));%10*
        end
    end
    ev=exp(0*2*log(b)+mvnrnd(zeros(p,1),N,1));%section 6.3.1 volatility model in VHGPR
    Ev=diag(ev);
    eta=100;%100
    l=10;%1
    for i=1:p
        for j=1:p
            K(i,j)=l*exp(-inv(eta)*[abs(t(i)-t(j))^2]);%5*(t(i)*t(j)*min(t(i),t(j))/2-(min(t(i),t(j))^3)/6);%0*1000 o 1000*
        end
    end
    K=K+0.01*eye(p);
    ki=chi2inv(1-q/m,p);%for chi-squared CI  
    %G=G(sel,:);%use of sel
    %y=y(sel);
    f=mvnrnd(zeros(p,1),K,1)';%there is no true function !
    ytrue=f+sqrt(ev)'.*randn(p,1);
    figure;plot(t,f);hold on;plot(t,ytrue,'ko');
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LS and ReLS%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %normalization
    G=Ev^(-0.5);
    y=Ev^(-0.5)*ytrue;
    o2=1;
    LS=inv(G'*G)*G'*y;%LS
    %o2LS=o2*(KnownVar==1)+(norm(y-G*LS)^2/(Ntr-p))*(KnownVar==0);%o2 used by LS
    E{1}=o2*inv(G'*G);
    C=inv(K);
    H=o2*C;%all the measurements y2 are affected by noise of variance o2 !
    G2=real([G;-H^0.5]);%chol(H)' could be H^0.5
    y2=[y;zeros(p,1)];
    ReLS=inv(G2'*G2)*G2'*y2;%ReLS
    E{2}=o2*inv(G2'*G2);%posterior from ReLS
    [Tsel3,Close3,Fit3,flag3] = Gaussgibbs(E{2},ki,f,ReLS,Runs);%ReLS+Gauss
    %not usable
    [Tsel8b,Close8b,Fit8b,Close8Fastb,V8b,flag8b,~,up8b,down8b] = SPSindsamp(G2,y2,ReLS,q,m,f,6,o2);%'ReLS+SPS3',o2);%Signs meas, Gaussian f
    [Tsel9,Close9,Fit9,Close9Fast,V9,flag9,~,up9,down9] = SPSindsamp(G2,y2,ReLS,q,m,f,7,o2);%'ReLS+SPS4',o2);%Gaussian meas, Gaussian f
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%% REGULARIZED LEAST SQUARES ReLS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %without normalization
    G=eye(p);
    y=ytrue;
    LS=inv(G'*G)*G'*y;%LS
    %o2LS=o2*(KnownVar==1)+(norm(y-G*LS)^2/(Ntr-p))*(KnownVar==0);%o2 used by LS
    E{1}=o2*inv(G'*G);
    C=inv(K);
    H=o2*C;%all the measurements y2 are affected by noise of variance o2 !
    G2=real([G;-H^0.5]);%chol(H)' could be H^0.5
    y2=[y;zeros(p,1)];
    ReLS2=inv(G2'*G2)*G2'*y2;%ReLS
    E{2}=o2*inv(G2'*G2);%posterior from ReLS
    [Tsel8,Close8,Fit8,Close8Fast,V8,flag8,~,up8,down8] = SPSindsamp(G2,y2,ReLS,q,m,f,6,o2);%'ReLS+SPS3',o2);%Signs meas, Gaussian f
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %clc
    %disp('LS+SPS LS+Gauss ReLS+Gauss ReLS+SPS1 ReLS+SPS2 ReLS+SPS1g ReLS+SPS2g ReLS+SPS3 ReLS+SPS4')
    %Flag(gian,:)=[flag1 flag2 flag3(1) flag4(1) flag5 flag6 flag7 flag8 flag9]
    %Close(gian,:)=[Close1 Close2  Close3  Close4  Close5 Close6 Close7 Close8 Close9]
    %Fit(gian,:)=[Fit1   Fit2   Fit3  Fit4   Fit5 Fit6 Fit7 Fit8 Fit9]
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
end

%%%%%%%%%%
AxFont=24;
xlabFont=28;
xlabFont2=28;%for final MSE plot
InLabFont=24;
tg=[0.01:0.01:t(end)];
fg=interp1(t,f,tg,'cubic');

fig=figure;plot(t,ev,'k','LineWidth',2);
h=get(fig,'Children');set(h,'Fontsize',AxFont);grid on
%legend('True','Estimate','Location','northeast')
title('Noise variances','FontSize',xlabFont);a=axis;


red=20;
fig=figure;
for i=red:red:size(Tsel9,1);Q(i/red,:)=Tsel9(i,:)';end;
plot(tg,fg,'r','LineWidth',3);hold on
%plot(t,ReLS,'k','LineWidth',3);a=axis;
legend('True','Location','northeast')%,'Estimate','Location','northeast')
plot(t,Q');hold on;plot(t,ytrue,'ko');clear Q;
plot(tg,fg,'r','LineWidth',3);hold on
%plot(t,ReLS,'k','LineWidth',3);
h=get(fig,'Children');set(h,'Fontsize',AxFont);grid on
legend('True','Location','northeast')%,'Estimate','Location','northeast')
title('Gaussian bounds','FontSize',xlabFont);a=axis;%a(1)=0.8;a(2)=p+0.2;a(4)=2.2;a(3)=-1.8;axis(a)
%axis([1 100 -6 14])
%xlabel('Time','FontSize',28)


%plot(up11);plot(down11)
%legend('True','95% bounds','Location','northwest' )
%print -depsc Ex3Fig2

fig=figure;
for i=red:red:size(Tsel8,1);Q(i/red,:)=Tsel8(i,:)';end;
plot(tg,fg,'r','LineWidth',3);hold on
%plot(t,ReLS2,'k','LineWidth',3);
legend('True','Location','northeast')%,'Estimate','Location','northeast')
plot(t,Q');hold on;plot(t,ytrue,'ko');clear Q;
plot(tg,fg,'r','LineWidth',3);hold on
%plot(t,ReLS2,'k','LineWidth',3);
h=get(fig,'Children');set(h,'Fontsize',AxFont);grid on
legend('True','Location','northeast')%,'Estimate','Location','northeast')
title('BFB','FontSize',xlabFont);axis(a);%a=axis;a(1)=0.8;a(2)=p+0.2;a(4)=2.2;a(3)=-1.8;
%axis([1 100 -6 14])%xlabel('Time','FontSize',28)
%plot(up11);plot(down11)
%legend('True','95% bounds','Location','northwest' )


% fig=figure;
% for i=red:red:size(Tsel8b,1);Q(i/red,:)=Tsel8b(i,:)';end;
% plot(tg,fg,'r','LineWidth',3);hold on
% %plot(t,ReLS2,'k','LineWidth',3);
% legend('True','Location','northeast')%,'Estimate','Location','northeast')
% plot(t,Q');hold on;plot(t,ytrue,'ko');clear Q;
% plot(tg,fg,'r','LineWidth',3);hold on
% %plot(t,ReLS2,'k','LineWidth',3);
% h=get(fig,'Children');set(h,'Fontsize',AxFont);grid on
% %legend('True','Estimate','Location','northeast')
% title('BFB','FontSize',xlabFont);axis(a);%a=axis;a(1)=0.8;a(2)=p+0.2;a(4)=2.2;a(3)=-1.8;
% %xlabel('Time','FontSize',28)
% if CreaFig==1
%     print -depsc ExHetGR4
% end
% %plot(up11);plot(down11)
% %legend('True','95% bounds','Location','northwest' )
% %print -depsc ExHetGR3




%i parametri del prior permettono di far variare l'accelerazione velocemente come si vede all inizio ma non 
%c'e' cosi' tanta incertezza dopo anche se i dati fanno schifo

% for i=10:10:size(Tsel3,1);Q(i/10,:)=Tsel3(i,:)';end
% plot(Q');hold on;plot(sel,y,'ko');hold on;plot(f,'r','LineWidth',2);clear Q;figure
% for i=20:20:size(Tsel8,1);Q(i/20,:)=Tsel8(i,:)';end;
% plot(Q');hold on;plot(sel,y,'ko');hold on;plot(f,'r','LineWidth',2);a=axis;clear Q;figure;
% for i=20:20:size(Tsel9,1);Q(i/20,:)=Tsel9(i,:)';end;
% plot(Q');hold on;plot(sel,y,'ko');axis(a);hold on;plot(f,'r','LineWidth',2);
%close all
%figure
%plot(Tsel1');hold on;plot(f,'LineWidth',2)
%figure
%plot(Tsel2');hold on;plot(f,'LineWidth',2)
%figure
%plot(Tsel3(10:10:end,:)');hold on;plot(f,'LineWidth',2);%a=axis;figure(1);axis(a)
%figure
%plot(Tsel4');hold on;plot(f,'LineWidth',2)


% function [f,K]=Genf(lab,Randf,p);
% 
% if lab=='CS'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=(i*j*min(i,j)/2-(min(i,j)^3)/6);%Cubic spline
%         end;
%     end
%     f=mvnrnd(zeros(p,1),K,1)';
% elseif lab=='RW'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=min(i,j);%Random walk
%         end;
%     end
%     f=mvnrnd(zeros(p,1),K,1)';
% elseif lab=='LP'
%     K=eye(p);
%     f=sign(randn(p,1)).*exprnd(1,p,1)/sqrt(2);%Laplace of unit variance
% elseif lab=='TC'
%     for i=1:p;
%         for j=1:p;
%             K(i,j)=0.8^max(i,j);%Stable spline
%         end;
%     end
%     if Randf==1
%         f=mvnrnd(zeros(p,1),K,1)';
%     else
%         load IR%impulse response f
%         if length(f)<p
%             f(length(f)+1:p)=0;
%         elseif length(f)>p
%             f=f(1:p);
%         end
%     end
% end

%end
